﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Data;
using System.Windows.Threading;
using Telerik.Windows.Controls.ChartView;

namespace ScatterSeries
{
    public partial class MainWindow : Window
	{
        public IEnumerable<PlotInfo> Data { get; set; }
        public IEnumerable<PlotInfo> Data2 { get; set; }
        Random rnd = new Random();
        
        public MainWindow()
		{
            Data = GetData();
            Data2 = GetData();
            InitializeComponent();
            
            DataContext = this;

            // The following line series gets added to the chart, but the data points
            // do not get styling when button is clicked
            var binding = new Binding(nameof(this.Data2)) { Source = this };
            var lineSeries = new ScatterLineSeries()
            {
                XValueBinding = new GenericDataPointBinding<PlotInfo, int>() { ValueSelector = p => p.ValueX },
                YValueBinding = new GenericDataPointBinding<PlotInfo, int>() { ValueSelector = p => p.ValueY }
            };

            lineSeries.SetBinding(ScatterLineSeries.ItemsSourceProperty, binding);
            CartesianChart.Series.Add(lineSeries);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var seriesList = new List<CartesianSeries>();
            foreach (var series in CartesianChart.Series)
            {
                if (series is ScatterLineSeries)
                {
                    //series.DefaultVisualStyle = this.Resources["DataPointStyle"] as Style;
                    series.PointTemplate = this.Resources["PointTemplate"] as DataTemplate;
                    seriesList.Add(series);
                }
            }
            
            // Remove and add the series back to apply styling on data points
            foreach (var series in seriesList)
            {
                CartesianChart.Series.Remove(series);
                CartesianChart.Series.Add(series);
            
            }

           
        }

        private IEnumerable<PlotInfo> GetData()
        {
            var data = new List<PlotInfo>();
            for (int i = 0; i < 10; i++)
            {
                PlotInfo product = new PlotInfo();
                product.ValueX = rnd.Next(10, 99);
                product.ValueY = rnd.Next(10, 99);
                data.Add(product);
            }
            return data;
        }
    }

    public class PlotInfo
    {
        public int ValueX { get; set; }
        public int ValueY { get; set; }
    }
}
